diff --git a/drivers/clk/imx/Kconfig b/drivers/clk/imx/Kconfig
index db0253f..09fc8ad 100644
--- a/drivers/clk/imx/Kconfig
+++ b/drivers/clk/imx/Kconfig
@@ -8,6 +8,96 @@ config MXC_CLK_SCU
 	bool
 	depends on IMX_SCU
 
+config CLK_IMX1
+         bool "IMX1 CCM Clock Driver"
+         depends on SOC_IMX1 || COMPILE_TEST
+         default SOC_IMX1
+         select MXC_CLK
+
+config CLK_IMX21
+         bool "IMX21 CCM Clock Driver"
+         depends on SOC_IMX21 || COMPILE_TEST
+         default SOC_IMX21
+         select MXC_CLK
+
+config CLK_IMX25
+         bool "IMX25 CCM Clock Driver"
+         depends on SOC_IMX25 || COMPILE_TEST
+         default SOC_IMX25
+         select MXC_CLK
+
+config CLK_IMX27
+         bool "IMX27 CCM Clock Driver"
+         depends on SOC_IMX27 || COMPILE_TEST
+         default SOC_IMX27
+         select MXC_CLK
+
+config CLK_IMX31
+         bool "IMX31 CCM Clock Driver"
+         depends on SOC_IMX31 || COMPILE_TEST
+         default SOC_IMX31
+         select MXC_CLK
+
+config CLK_IMX35
+         bool "IMX35 CCM Clock Driver"
+         depends on SOC_IMX35 || COMPILE_TEST
+         default SOC_IMX35
+         select MXC_CLK
+
+config CLK_IMX5
+         bool "IMX5 CCM Clock Driver"
+         depends on SOC_IMX5 || COMPILE_TEST
+         default SOC_IMX5
+         select MXC_CLK
+
+config CLK_IMX6Q
+         bool "IMX6Q CCM Clock Driver"
+         depends on SOC_IMX6Q || COMPILE_TEST
+         default SOC_IMX6Q
+         select MXC_CLK
+
+config CLK_IMX6SL
+         bool "IMX6SL CCM Clock Driver"
+         depends on SOC_IMX6SL || COMPILE_TEST
+         default SOC_IMX6SL
+         select MXC_CLK
+
+config CLK_IMX6SLL
+         bool "IMX6SLL CCM Clock Driver"
+         depends on SOC_IMX6SLL || COMPILE_TEST
+         default SOC_IMX6SLL
+         select MXC_CLK
+
+config CLK_IMX6SX
+         bool "IMX6SX CCM Clock Driver"
+         depends on SOC_IMX6SX || COMPILE_TEST
+         default SOC_IMX6SX
+         select MXC_CLK
+
+config CLK_IMX6UL
+         bool "IMX6UL CCM Clock Driver"
+         depends on SOC_IMX6UL || COMPILE_TEST
+         default SOC_IMX6UL
+         select MXC_CLK
+
+config CLK_IMX7D
+         bool "IMX7D CCM Clock Driver"
+         depends on SOC_IMX7D || COMPILE_TEST
+         default SOC_IMX7D
+         select MXC_CLK
+
+config CLK_IMX7ULP
+         bool "IMX7ULP Clock Driver"
+         depends on SOC_IMX7ULP || COMPILE_TEST
+         default SOC_IMX7ULP
+         select MXC_CLK
+
+config CLK_VF610
+         bool "VF610 Clock Driver"
+         depends on SOC_VF610 || COMPILE_TEST
+         default SOC_VF610
+         select MXC_CLK
+
 config CLK_IMX8MM
 	bool "IMX8MM CCM Clock Driver"
 	depends on ARCH_MXC
diff --git a/drivers/clk/imx/Makefile b/drivers/clk/imx/Makefile
index 928f874..394ade7 100644
--- a/drivers/clk/imx/Makefile
+++ b/drivers/clk/imx/Makefile
@@ -31,18 +31,18 @@ obj-$(CONFIG_CLK_IMX8MP) += clk-imx8mp.o
 obj-$(CONFIG_CLK_IMX8MQ) += clk-imx8mq.o
 obj-$(CONFIG_CLK_IMX8QXP) += clk-imx8qxp.o clk-imx8qxp-lpcg.o
 
-obj-$(CONFIG_SOC_IMX1)   += clk-imx1.o
-obj-$(CONFIG_SOC_IMX21)  += clk-imx21.o
-obj-$(CONFIG_SOC_IMX25)  += clk-imx25.o
-obj-$(CONFIG_SOC_IMX27)  += clk-imx27.o
-obj-$(CONFIG_SOC_IMX31)  += clk-imx31.o
-obj-$(CONFIG_SOC_IMX35)  += clk-imx35.o
-obj-$(CONFIG_SOC_IMX5)   += clk-imx5.o
-obj-$(CONFIG_SOC_IMX6Q)  += clk-imx6q.o
-obj-$(CONFIG_SOC_IMX6SL) += clk-imx6sl.o
-obj-$(CONFIG_SOC_IMX6SLL) += clk-imx6sll.o
-obj-$(CONFIG_SOC_IMX6SX) += clk-imx6sx.o
-obj-$(CONFIG_SOC_IMX6UL) += clk-imx6ul.o
-obj-$(CONFIG_SOC_IMX7D)  += clk-imx7d.o
-obj-$(CONFIG_SOC_IMX7ULP) += clk-imx7ulp.o
-obj-$(CONFIG_SOC_VF610)  += clk-vf610.o
+obj-$(CONFIG_CLK_IMX1)   += clk-imx1.o
+obj-$(CONFIG_CLK_IMX21)  += clk-imx21.o
+obj-$(CONFIG_CLK_IMX25)  += clk-imx25.o
+obj-$(CONFIG_CLK_IMX27)  += clk-imx27.o
+obj-$(CONFIG_CLK_IMX31)  += clk-imx31.o
+obj-$(CONFIG_CLK_IMX35)  += clk-imx35.o
+obj-$(CONFIG_CLK_IMX5)   += clk-imx5.o
+obj-$(CONFIG_CLK_IMX6Q)  += clk-imx6q.o
+obj-$(CONFIG_CLK_IMX6SL) += clk-imx6sl.o
+obj-$(CONFIG_CLK_IMX6SLL) += clk-imx6sll.o
+obj-$(CONFIG_CLK_IMX6SX) += clk-imx6sx.o
+obj-$(CONFIG_CLK_IMX6UL) += clk-imx6ul.o
+obj-$(CONFIG_CLK_IMX7D)  += clk-imx7d.o
+obj-$(CONFIG_CLK_IMX7ULP) += clk-imx7ulp.o
+obj-$(CONFIG_CLK_VF610)  += clk-vf610.o